/* userDataHandling.c
 *
 * Author: Thomas Wiens, Juli 2009
 *
 * Handling of User Data requests (0x07)
 * 
 * SZL-Infos taken from libnodave (simProperties.c) (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2002..2005
 */

#include "userDataHandling.h"

int runStop = runModeRun;	// As response to SZL-ID 1060 Index 0 (runModeRun / runModeStop)

uc SZL_0_0[] = { 0,2,0,53, //    53 elements of 2 bytes
0x00,0x00,
0x0F,0x00,
0x00,0x11,
0x01,0x11,
0x0F,0x11,
0x00,0x12,
0x01,0x12,
0x0F,0x12,
0x00,0x13,
0x00,0x14,
0x00,0x15,
0x01,0x15,
0x00,0x17,
0x01,0x17,
0x0F,0x17,
0x00,0x18,
0x01,0x18,
0x0F,0x18,
0x00,0x19,
0x0F,0x19,
0x0F,0x1A,
0x0F,0x1B,
0x00,0x1A,
0x00,0x1B,
0x00,0x21,
0x0A,0x21,
0x0F,0x21,
0x02,0x22,
0x00,0x23,
0x0F,0x23,
0x00,0x24,
0x01,0x24,
0x04,0x24,
0x05,0x24,
0x01,0x31,
0x01,0x32,
0x02,0x32,
0x00,0x74,
0x01,0x74,
0x0F,0x74,
0x0C,0x91,
0x0D,0x91,
0x0A,0x91,
0x00,0x92,
0x02,0x92,
0x06,0x92,
0x0F,0x92,
0x00,0xB1,
0x00,0xB2,
0x00,0xB3,
0x00,0xB4,
0x00,0xA0,
0x01,0xA0,
};

uc SZL_25_0[] = { 
0x0,0x19,0,0,		// 25, 0
0,4,0,5, // 5 elements of 4 bytes
0x00,0x01,0x00,0x00,
0x00,0x04,0x01,0x00,
0x00,0x05,0x00,0x00,
0x00,0x06,0x00,0x00,
0x00,0x08,0x01,0x00,
};

uc SZL_273_1[] = { 
0x1,0x11,0,1,		// 273,1
0,28,0,1, // 1 element of 28 bytes
0x00,0x08,'6','E','S','7',' ','3','1','5','-','2','A','F','0','3','-','0','A','B','0',' ',0x00,0xC0,0x00,0x02,0x00,0x00,
};

uc SZL_274_512[] = { 
0x1,0x12,2,0,		// result SZL ID 0112 200 	274, 512 
0,2,0,0, // 0 elements of 2
};


uc SZL_292_0[] = { 
0x1,0x24,0,0,		// result SZL ID 0124 00 
0,20,0,1,		// 1 elements of 20 bytes
0x43,0x02,0xFF,0x68,0xC7,0x00,0x00,0x00,0x00,0x24,0x07,0x24,0x04,0x03,0x21,0x05,0x17,0x42,0x61,0x01,
};


uc SZL_305_1[] = { 
0x1,0x31,0,1,		// 305,1
0,40,0,1, // 1 element of 40 bytes
0x00,0x01,0x00,0xF0,0x00,0x0C,0x00,0x02,0xDC,0x6C,0x00,0x02,0xDC,0x6C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};

uc SZL_305_2[] = {
0x1,0x31,0,2,		// 305,2
0,40,0,1, // 1 element of 40 bytes
0x00,0x02,0xBE,0xFD,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x01,0x00,0x00,0x00,0x00,0x7D,0x00,0x00,0x05,0x03,0x04,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x0A,0x00,0x00,0x00,0x09,0x00,0x00,
};

// 0x0131 index 3
// communication parameters
uc SZL_305_3[] = { 
0x1,0x31,0,3,		// 305,3
0,40,0,1, // 1 element of 40 bytes

0x00,0x03, 	// index
0x00,		// funkt_0: changed from 0x7f to 0x00 (no cyclic functions available)
0xf0,		// funkt_1
0x83,		// funkt_2
0x01,		// funkt_3
0x00,0x00,	// data, (maximum size of concistently readable data
0x00,0x00,	// anz (maximum number of cyclic read jobs
0x00,0x01,	// per_min
0x02,0x09,	// per_man
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // res

};

uc SZL_305_4[] = {
0x1,0x31,0,4,		// 305,4
0,40,0,1, // 1 element of 40 bytes
0x00,0x04,0xFE,0x01,0x22,0x41,0x23,0x00,0x00,0x00,0x10,0x10,0x10,0x04,0x02,0x00,0x00,0x02,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};

uc SZL_305_5[] = { 
0x1,0x31,0,5,		// 305,5
0,40,0,1, // 1 element of 40 bytes
0x00,0x05,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x64,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};

uc SZL_305_6[] = { 
0x1,0x31,0,6,		// 305,6
0,40,0,1, // 1 element of 40 bytes
0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x0E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x4C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};

uc SZL_305_7[] = { 
0x1,0x31,0,7,		// 305,7
0,40,0,1, // 1 element of 40 bytes
0x00,0x07,0x01,0x00,0x3F,0x00,0x08,0x01,0x01,0x00,0x00,0x00,0x01,0x04,0x01,0x04,0x01,0x04,0x20,0x08,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};

uc SZL_305_8[] = { 
0x1,0x31,0,8,		// 305,8
0,40,0,1, // 1 element of 40 bytes
0x00,0x08,0x70,0x10,0x70,0x06,0x70,0x06,0x41,0xF4,0x41,0xF4,0x41,0xF4,0x41,0xF4,0x43,0x20,0x43,0x20,0x43,0x20,0x43,0x20,0x43,0x20,0x43,0x20,0x43,0x20,0x43,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};

uc SZL_305_9[] = { 
0x1,0x31,0,9,		// 305,9
0,40,0,1, // 1 element of 40 bytes
0x00,0x09,0x04,0x06,0x01,0x00,0x01,0xF7,0x01,0xF7,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};

uc SZL_305_16[] = { 
0x1,0x31,0,16,		// 305,16
0,40,0,1, // 1 element of 40 bytes
0x00,0x10,0x1f,0x00,0x1f,0x00,0x3f,0x00,0x7f,0x00,0x00,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};

uc SZL_306_1[] = { 
0x1,0x32,0,1,	//result SZL ID 0132 01
0,40,0,1,	//1 elements of 40 bytes
0x51,0x0f,0xff,0x04,0xc7,0x00,0x00,0x00,0x00,0x20,0x07,0x23,0x10,0x02,0x25,0x18,0x15,0x23,0x87,0x15
};

uc SZL_306_2[] = { 
0x1,0x32,0,2,	//result SZL ID 0132 02
0,40,0,1,	//1 elements of 40 bytes
0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x05,0x00,0x0E,0x00,0x00,0x00,0x00,0x06,0x01,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};

uc SZL_306_4[] = { 
0x1,0x32,0,4,	//result SZL ID 0132 04 
0,40,0,1,	//1 elements of 40 bytes
/*
Run:  0x00,0x04,0x00,0x02,0x00,0x00,0x00,0x02,0x00,0x01,0x00,0x00,0x00,0x00,0x56,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
*/
/* RunP: */
 0x00,0x04,0x00,0x01,0x00,0x00,0x00,0x01,0x00,0x02,0x00,0x00,0x00,0x00,0x56,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
/* Stop: 
0x00,0x04,0x00,0x01,0x00,0x00,0x00,0x01,0x00,0x03,0x00,0x00,0x00,0x00,0x56,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
*/

};

uc SZL_306_6[] = { 
0x1,0x32,0,6,	//result SZL ID 0132 02
0,40,0,1,	//1 elements of 40 bytes
0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};

uc SZL_1060_0[] = { 
0x4,0x24,0,0,	//    result SZL ID 0424 00 
0,20,0,1,	//    1 elements of 20 bytes
0x51,0x42,0xFF,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x03,0x21,0x06,0x31,0x41,0x49,0x61,
};

uc SZL_1060_0S[] = { 
0x4,0x24,0,0,	//    result SZL ID 0424 00 
0,20,0,1,	//    1 elements of 20 bytes
0x51,0x0B,0xFF,0x03,0xC7,0x00,0x00,0x00,0x00,0x10,0x07,0x20,0x04,0x03,0x19,0x21,0x39,0x45,0x29,0x06,
};

uc SZL_1060_0RP[] = { 
0x51,0x42,0xFF,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x03,0x21,0x15,0x27,0x35,0x93,0x71,
};

uc SZL_1316_20480[] = { 
0x5,0x24,0x50,0x0,	//result SZL ID 0524 5000 
0,20,0,1,	//    1 elements of 20 bytes
0x51,0x0B,0xFF,0x03,0xC7,0x00,0x00,0x00,0x00,0x10,0x07,0x20,0x04,0x03,0x19,0x21,0x39,0x45,0x29,0x06,
};

uc SZL_3473_0[] = { 
0xd,0x91,0,0,
0,16,0,1, // SZL-ID 0D91 index 00, 1 element of 16 bytes
0x00,0x00,0x02,0x00,0x7F,0xFF,0x00,0xC0,0x00,0xC0,0x00,0x00,0xB4,0x02,0x00,0x11,
};

////////////////////////////////////////////////////////////////////////////
///
////////////////////////////////////////////////////////////////////////////

int handleSZL(int number, int index, PDU * p2){

    if ((number == 292) && (index == 0)) {
		uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x84,0x01,0x01, 0x00,0x00,0x00,0x00,}; 
		_daveInitPDUheader(p2, 7);
		_daveAddParam(p2, pa, sizeof(pa));
		_daveAddUserData(p2, SZL_292_0, sizeof(SZL_292_0));
		if (daveDebug & daveDebugPDU) _daveDumpPDU(p2);    
		return 1;
    } else if ((number == 274) && (index == 512)) {	/* read order code (MLFB) */
		uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x84,0x01,0x01, 0x00,0x00,0x00,0x00,}; 
		_daveInitPDUheader(p2, 7);
		_daveAddParam(p2, pa, sizeof(pa));
		_daveAddUserData(p2, SZL_274_512, sizeof(SZL_274_512));
		if (daveDebug & daveDebugPDU) _daveDumpPDU(p2);    
		return 1;	
    } else if ((number == 0) && (index == 0)) {
		uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x84,0x01,0x01, 0x00,0x00,0x00,0x00,}; 
		_daveInitPDUheader(p2, 7);
		_daveAddParam(p2, pa, sizeof(pa));
		_daveAddUserData(p2, SZL_0_0, sizeof(SZL_0_0));
		if (daveDebug & daveDebugPDU) _daveDumpPDU(p2);    
		return 1;
    } else if ((number == 25) && (index == 0)) {	
		uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x84,0x01,0x01, 0x00,0x00,0x00,0x00,}; 
		_daveInitPDUheader(p2, 7);
		_daveAddParam(p2, pa, sizeof(pa));
		_daveAddUserData(p2, SZL_25_0, sizeof(SZL_25_0));
		if (daveDebug & daveDebugPDU) _daveDumpPDU(p2);    
		return 1;		
    } else if ((number == 273) && (index == 1)) {	/* read order code (MLFB) */
		uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x84,0x01,0x01, 0x00,0x00,0x00,0x00,}; 
		_daveInitPDUheader(p2, 7);
		_daveAddParam(p2, pa, sizeof(pa));
		_daveAddUserData(p2, SZL_273_1, sizeof(SZL_273_1));
		if (daveDebug & daveDebugPDU) _daveDumpPDU(p2);    
		return 1;
    } else if (number == 305) {
		uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x84,0x01,0x01, 0x00,0x00,0x00,0x00,};
		_daveInitPDUheader(p2, 7);
		_daveAddParam(p2, pa, sizeof(pa));
		
		switch (index) {
			case 1: _daveAddUserData(p2, SZL_305_1, sizeof(SZL_305_1)); break;
			case 2: _daveAddUserData(p2, SZL_305_2, sizeof(SZL_305_2)); break;
			case 3: _daveAddUserData(p2, SZL_305_3, sizeof(SZL_305_3)); break;
			case 4: _daveAddUserData(p2, SZL_305_4, sizeof(SZL_305_4)); break;
			case 5: _daveAddUserData(p2, SZL_305_5, sizeof(SZL_305_5)); break;
			case 6: _daveAddUserData(p2, SZL_305_6, sizeof(SZL_305_6)); break;
			case 7: _daveAddUserData(p2, SZL_305_7, sizeof(SZL_305_7)); break;
			case 8: _daveAddUserData(p2, SZL_305_8, sizeof(SZL_305_8)); break;
			case 9: _daveAddUserData(p2, SZL_305_9, sizeof(SZL_305_9)); break;
			case 16: _daveAddUserData(p2, SZL_305_16, sizeof(SZL_305_16)); break;
		}
		if (daveDebug & daveDebugPDU) _daveDumpPDU(p2);    
		return 1;
	} else if (number == 306) {
		uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x84,0x01,0x01, 0x00,0x00,0x00,0x00,}; 
		_daveInitPDUheader(p2, 7);
		_daveAddParam(p2, pa, sizeof(pa));
		switch (index) {
			case 1: _daveAddUserData(p2, SZL_306_1, sizeof(SZL_306_1)); break;
			case 2: _daveAddUserData(p2, SZL_306_2, sizeof(SZL_306_2)); break;
			case 4: _daveAddUserData(p2, SZL_306_4, sizeof(SZL_306_4)); break;
			case 6: _daveAddUserData(p2, SZL_306_6, sizeof(SZL_306_6)); break;
		}
		if (daveDebug & daveDebugPDU) _daveDumpPDU(p2);    
		return 1;	
    } else if ((number == 0xD91) && (index == 0)) {	
		uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x84,0x01,0x01, 0x00,0x00,0x00,0x00,}; 
		_daveInitPDUheader(p2, 7);
		_daveAddParam(p2, pa, sizeof(pa));
		_daveAddUserData(p2, SZL_3473_0, sizeof(SZL_3473_0));
		if (daveDebug & daveDebugPDU) _daveDumpPDU(p2);    
		return 1;
    } else if ((number == 1060) && (index == 0)) {	
		uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x84,0x01,0x01, 0x00,0x00,0x00,0x00,}; 
		_daveInitPDUheader(p2, 7);
		_daveAddParam(p2, pa, sizeof(pa));
		if (runStop == runModeRun)
			_daveAddUserData(p2, SZL_1060_0, sizeof(SZL_1060_0));
		else if (runStop == runModeStop)    
			_daveAddUserData(p2, SZL_1060_0S, sizeof(SZL_1060_0S));
		if (daveDebug & daveDebugPDU) _daveDumpPDU(p2);    
		return 1;
    } else if ((number == 1316) && (index == 20480)) {	
		uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x84,0x01,0x01, 0x00,0x00,0x00,0x00,}; 
		_daveInitPDUheader(p2, 7);
		_daveAddParam(p2, pa, sizeof(pa));
        _daveAddUserData(p2, SZL_1316_20480, sizeof(SZL_1316_20480));
		if (daveDebug & daveDebugPDU) _daveDumpPDU(p2);    
		return 1;	
    } else {
		// uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x84,0x01,0x01, 0x00,0x00,0xD4,0x01,}; 
		uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x84,0x01,0x01, 0x00,0x00,0x00,0x00,}; 
		uc da[] = {0x0a,0x0,0x0,0x0,}; 
		_daveInitPDUheader(p2, 7);
		_daveAddParam(p2, pa, sizeof(pa));
        _daveAddData(p2, da, sizeof(da));
		if (daveDebug & daveDebugPDU) _daveDumpPDU(p2);    
		return 1;	
    }	
	
	// 0xD401: Unzulässige SZL-ID
	// 0xD402: Unzulässiger INDEX
}

////////////////////////////////////////////////////////////////////////////
///
////////////////////////////////////////////////////////////////////////////

int handleSystemMessage(PDU * p1,PDU * p2) {
    int number;
    int index;
		
    if (
			(p1->param[1] == 1 ) &&
			(p1->param[2] == 18) &&
			(p1->param[3] == 4 ) &&
			(p1->param[4] == 17) &&
			(p1->param[5] == 'D') 
		) {
		number = 0x100 * (p1->data[4]) + p1->data[5];
		index  = 0x100 * (p1->data[6]) + p1->data[7];
		//printf("SZL read ID: %04X index: %d\n", number, index);
		return handleSZL(number, index, p2);
    } else if (
		(p1->param[1] == 1 ) &&
		(p1->param[2] == 18) &&
		(p1->param[3] == 4 ) &&
		(p1->param[4] == 17) &&
		(p1->param[5] == 'C') 
		) {
		printf("Block functions\n");
        return 0;													//handleBlocks(p1, p2);
    }
    else if (
			(p1->param[1] == 1 ) &&
			(p1->param[2] == 18) &&
			(p1->param[3] == 4 ) &&
			(p1->param[4] == 17) &&
			(p1->param[5] == 'G') 
		) {
		printf("Time System ????\n");
		return 0;													// handleTime(p1, p2);
    } else if (
			(p1->param[1] == 1 ) &&
			(p1->param[2] == 18) &&
			(p1->param[3] == 8 ) &&
			(p1->param[4] == 18) &&
			(p1->param[5] == 'A')  
		) {
		if(p1->param[6] == 16) { 
			printf("Forces ???? ????\n");
			uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x81,0x10,0x00, 0x00,0x00,0xD0,0x02,}; 
			uc da[] = {0,4,0,4,1,0,0,1,16,1,0,0}; 
			_daveInitPDUheader(p2, 7);
			_daveAddParam(p2, pa, sizeof(pa));
			_daveAddData(p2, da, sizeof(da));
			_daveDumpPDU(p2);    
			return 1;	
		} else if(p1->param[6] == 12) { 
			printf("Erase ???? ????\n");
			uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x81,0x12,0x00, 0x00,0x00,0x0,0x0,}; 
			uc da[] = {0x0a,0x0,0x0,0x0,}; 
			_daveInitPDUheader(p2, 7);
			_daveAddParam(p2, pa, sizeof(pa));
			_daveAddData(p2, da, sizeof(da));
			_daveDumpPDU(p2);    
			return 1;	
		} else {
			printf("Programmer Commands(%d) ???? ????\n", p1->param[6]);
			uc pa[] = {0x00,0x01,0x12,0x08,0x12,0x81,0x10,0x00, 0x00,0x00,0xD0,0x04,}; 
			uc da[] = {0x0a,0x0,0x0,0x0,}; 
			pa[6] = p1->param[6];
			_daveInitPDUheader(p2, 7);
			_daveAddParam(p2, pa, sizeof(pa));
			_daveAddData(p2, da, sizeof(da));
			_daveDumpPDU(p2);    
			return 1;	
		}
    }
    printf("Cannot handle this!\n");
    return 0;
}

